/*     */ package com.medicwave.cardgame.poker;
/*     */ 
/*     */ import java.lang.reflect.InvocationTargetException;
/*     */ import javax.swing.GroupLayout.SequentialGroup;
/*     */ import javax.swing.JLabel;
/*     */ import javax.swing.JMenuItem;
/*     */ import javax.swing.JPanel;
/*     */ import javax.swing.JProgressBar;
/*     */ import javax.swing.JTextArea;
/*     */ 
/*     */ public class PokerServerGuiView extends org.jdesktop.application.FrameView
/*     */ {
/*     */   private JPanel mainPanel;
/*     */   private javax.swing.JMenuBar menuBar;
/*     */   private JProgressBar pbProgress;
/*     */   private JPanel pnlMessages;
/*     */   private javax.swing.JScrollPane spMessages;
/*     */   private JMenuItem startMenuItem;
/*     */   private JLabel statusAnimationLabel;
/*     */   private JLabel statusMessageLabel;
/*     */   private JPanel statusPanel;
/*     */   private javax.swing.JTabbedPane tabMain;
/*     */   private JTextArea txtMessages;
/*     */   private final javax.swing.Timer messageTimer;
/*     */   private final javax.swing.Timer busyIconTimer;
/*     */   private final javax.swing.Icon idleIcon;
/*     */   
/*     */   public PokerServerGuiView(org.jdesktop.application.SingleFrameApplication app)
/*     */   {
/*  30 */     super(app);
/*     */     
/*  32 */     initComponents();
/*     */     
/*     */ 
/*  35 */     org.jdesktop.application.ResourceMap resourceMap = getResourceMap();
/*  36 */     int messageTimeout = resourceMap.getInteger("StatusBar.messageTimeout").intValue();
/*  37 */     this.messageTimer = new javax.swing.Timer(messageTimeout, new java.awt.event.ActionListener() {
/*     */       public void actionPerformed(java.awt.event.ActionEvent e) {
/*  39 */         PokerServerGuiView.this.statusMessageLabel.setText("");
/*     */       }
/*  41 */     });
/*  42 */     this.messageTimer.setRepeats(false);
/*  43 */     int busyAnimationRate = resourceMap.getInteger("StatusBar.busyAnimationRate").intValue();
/*  44 */     for (int i = 0; i < this.busyIcons.length; i++) {
/*  45 */       this.busyIcons[i] = resourceMap.getIcon("StatusBar.busyIcons[" + i + "]");
/*     */     }
/*  47 */     this.busyIconTimer = new javax.swing.Timer(busyAnimationRate, new java.awt.event.ActionListener() {
/*     */       public void actionPerformed(java.awt.event.ActionEvent e) {
/*  49 */         PokerServerGuiView.this.busyIconIndex = ((PokerServerGuiView.this.busyIconIndex + 1) % PokerServerGuiView.this.busyIcons.length);
/*  50 */         PokerServerGuiView.this.statusAnimationLabel.setIcon(PokerServerGuiView.this.busyIcons[PokerServerGuiView.this.busyIconIndex]);
/*     */       }
/*  52 */     });
/*  53 */     this.idleIcon = resourceMap.getIcon("StatusBar.idleIcon");
/*  54 */     this.statusAnimationLabel.setIcon(this.idleIcon);
/*  55 */     this.pbProgress.setVisible(false);
/*     */     
/*     */ 
/*  58 */     org.jdesktop.application.TaskMonitor taskMonitor = new org.jdesktop.application.TaskMonitor(getApplication().getContext());
/*  59 */     taskMonitor.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
/*     */       public void propertyChange(java.beans.PropertyChangeEvent evt) {
/*  61 */         String propertyName = evt.getPropertyName();
/*  62 */         if ("started".equals(propertyName)) {
/*  63 */           if (!PokerServerGuiView.this.busyIconTimer.isRunning()) {
/*  64 */             PokerServerGuiView.this.statusAnimationLabel.setIcon(PokerServerGuiView.this.busyIcons[0]);
/*  65 */             PokerServerGuiView.this.busyIconIndex = 0;
/*  66 */             PokerServerGuiView.this.busyIconTimer.start();
/*     */           }
/*  68 */           PokerServerGuiView.this.pbProgress.setVisible(true);
/*  69 */           PokerServerGuiView.this.pbProgress.setIndeterminate(true);
/*  70 */         } else if ("done".equals(propertyName)) {
/*  71 */           PokerServerGuiView.this.busyIconTimer.stop();
/*  72 */           PokerServerGuiView.this.statusAnimationLabel.setIcon(PokerServerGuiView.this.idleIcon);
/*  73 */           PokerServerGuiView.this.pbProgress.setVisible(false);
/*  74 */           PokerServerGuiView.this.pbProgress.setValue(0);
/*  75 */         } else if ("message".equals(propertyName)) {
/*  76 */           String text = (String)evt.getNewValue();
/*  77 */           PokerServerGuiView.this.statusMessageLabel.setText(text == null ? "" : text);
/*  78 */           PokerServerGuiView.this.messageTimer.restart();
/*  79 */         } else if ("progress".equals(propertyName)) {
/*  80 */           int value = ((Integer)evt.getNewValue()).intValue();
/*  81 */           PokerServerGuiView.this.pbProgress.setVisible(true);
/*  82 */           PokerServerGuiView.this.pbProgress.setIndeterminate(false);
/*  83 */           PokerServerGuiView.this.pbProgress.setValue(value);
/*     */         }
/*     */         
/*     */       }
/*     */       
/*  88 */     });
/*  89 */     this.pokerTable = new PokerTablePanel();
/*  90 */     this.tabMain.addTab("Table", this.pokerTable);
/*  91 */     this.tabMain.getModel().setSelectedIndex(0);
/*     */     
/*  93 */     getFrame().setSize(640, 480);
/*     */   }
/*     */   
/*     */   @org.jdesktop.application.Action
/*     */   public void showAboutBox() {
/*  98 */     if (this.aboutBox == null) {
/*  99 */       javax.swing.JFrame mainFrame = PokerServerGuiApp.getApplication().getMainFrame();
/* 100 */       this.aboutBox = new PokerServerGuiAboutBox(mainFrame);
/* 101 */       this.aboutBox.setLocationRelativeTo(mainFrame);
/*     */     }
/* 103 */     PokerServerGuiApp.getApplication().show(this.aboutBox);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void initComponents()
/*     */   {
/* 115 */     this.mainPanel = new JPanel();
/* 116 */     this.tabMain = new javax.swing.JTabbedPane();
/* 117 */     this.pnlMessages = new JPanel();
/* 118 */     this.spMessages = new javax.swing.JScrollPane();
/* 119 */     this.txtMessages = new JTextArea();
/* 120 */     this.menuBar = new javax.swing.JMenuBar();
/* 121 */     javax.swing.JMenu fileMenu = new javax.swing.JMenu();
/* 122 */     this.startMenuItem = new JMenuItem();
/* 123 */     JMenuItem exitMenuItem = new JMenuItem();
/* 124 */     javax.swing.JMenu helpMenu = new javax.swing.JMenu();
/* 125 */     JMenuItem aboutMenuItem = new JMenuItem();
/* 126 */     this.statusPanel = new JPanel();
/* 127 */     javax.swing.JSeparator statusPanelSeparator = new javax.swing.JSeparator();
/* 128 */     this.statusMessageLabel = new JLabel();
/* 129 */     this.statusAnimationLabel = new JLabel();
/* 130 */     this.pbProgress = new JProgressBar();
/*     */     
/* 132 */     this.mainPanel.setName("mainPanel");
/* 133 */     this.mainPanel.setLayout(new java.awt.GridLayout(1, 0));
/*     */     
/* 135 */     this.tabMain.setName("tabMain");
/*     */     
/* 137 */     this.pnlMessages.setName("pnlMessages");
/* 138 */     this.pnlMessages.setLayout(new java.awt.GridLayout(1, 0));
/*     */     
/* 140 */     this.spMessages.setName("spMessages");
/*     */     
/* 142 */     this.txtMessages.setColumns(20);
/* 143 */     this.txtMessages.setEditable(false);
/* 144 */     this.txtMessages.setRows(5);
/* 145 */     this.txtMessages.setName("txtMessages");
/* 146 */     this.spMessages.setViewportView(this.txtMessages);
/*     */     
/* 148 */     this.pnlMessages.add(this.spMessages);
/*     */     
/* 150 */     org.jdesktop.application.ResourceMap resourceMap = ((PokerServerGuiApp)org.jdesktop.application.Application.getInstance(PokerServerGuiApp.class)).getContext().getResourceMap(PokerServerGuiView.class);
/* 151 */     this.tabMain.addTab(resourceMap.getString("pnlMessages.TabConstraints.tabTitle", new Object[0]), this.pnlMessages);
/*     */     
/* 153 */     this.mainPanel.add(this.tabMain);
/*     */     
/* 155 */     this.menuBar.setName("menuBar");
/*     */     
/* 157 */     fileMenu.setText(resourceMap.getString("fileMenu.text", new Object[0]));
/* 158 */     fileMenu.setName("fileMenu");
/*     */     
/* 160 */     javax.swing.ActionMap actionMap = ((PokerServerGuiApp)org.jdesktop.application.Application.getInstance(PokerServerGuiApp.class)).getContext().getActionMap(PokerServerGuiView.class, this);
/* 161 */     this.startMenuItem.setAction(actionMap.get("startPokerServer"));
/* 162 */     this.startMenuItem.setName("startMenuItem");
/* 163 */     fileMenu.add(this.startMenuItem);
/*     */     
/* 165 */     exitMenuItem.setAction(actionMap.get("quit"));
/* 166 */     exitMenuItem.setName("exitMenuItem");
/* 167 */     fileMenu.add(exitMenuItem);
/*     */     
/* 169 */     this.menuBar.add(fileMenu);
/*     */     
/* 171 */     helpMenu.setText(resourceMap.getString("helpMenu.text", new Object[0]));
/* 172 */     helpMenu.setName("helpMenu");
/*     */     
/* 174 */     aboutMenuItem.setAction(actionMap.get("showAboutBox"));
/* 175 */     aboutMenuItem.setName("aboutMenuItem");
/* 176 */     helpMenu.add(aboutMenuItem);
/*     */     
/* 178 */     this.menuBar.add(helpMenu);
/*     */     
/* 180 */     this.statusPanel.setName("statusPanel");
/*     */     
/* 182 */     statusPanelSeparator.setName("statusPanelSeparator");
/*     */     
/* 184 */     this.statusMessageLabel.setName("statusMessageLabel");
/*     */     
/* 186 */     this.statusAnimationLabel.setHorizontalAlignment(2);
/* 187 */     this.statusAnimationLabel.setName("statusAnimationLabel");
/*     */     
/* 189 */     this.pbProgress.setName("pbProgress");
/*     */     
/* 191 */     javax.swing.GroupLayout statusPanelLayout = new javax.swing.GroupLayout(this.statusPanel);
/* 192 */     this.statusPanel.setLayout(statusPanelLayout);
/* 193 */     statusPanelLayout.setHorizontalGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addComponent(statusPanelSeparator, -1, 772, 32767).addGroup(statusPanelLayout.createSequentialGroup().addContainerGap().addComponent(this.statusMessageLabel).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 602, 32767).addComponent(this.pbProgress, -2, -1, -2).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addComponent(this.statusAnimationLabel).addContainerGap()));
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 205 */     statusPanelLayout.setVerticalGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGroup(statusPanelLayout.createSequentialGroup().addComponent(statusPanelSeparator, -2, 2, -2).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, -1, 32767).addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).addComponent(this.statusMessageLabel).addComponent(this.statusAnimationLabel).addComponent(this.pbProgress, -2, -1, -2)).addGap(3, 3, 3)));
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 217 */     setComponent(this.mainPanel);
/* 218 */     setMenuBar(this.menuBar);
/* 219 */     setStatusBar(this.statusPanel);
/*     */   }
/*     */   
/*     */   @org.jdesktop.application.Action
/*     */   public void startPokerServer() {
/* 224 */     if (this.pokerServer != null)
/*     */     {
/* 226 */       this.txtMessages.append("Closing existing poker server...\n");
/* 227 */       this.pokerServer.close();
/* 228 */       this.txtMessages.append("...done.\n");
/*     */     }
/* 230 */     this.pokerTable.clearPlayers();
/*     */     
/* 232 */     if (this.dlgServerSetup == null) {
/* 233 */       javax.swing.JFrame mainFrame = PokerServerGuiApp.getApplication().getMainFrame();
/* 234 */       this.dlgServerSetup = new PokerServerSetupDialog(mainFrame, true);
/* 235 */       this.dlgServerSetup.setLocationRelativeTo(mainFrame);
/*     */     }
/* 237 */     PokerServerGuiApp.getApplication().show(this.dlgServerSetup);
/*     */     
/* 239 */     this.txtMessages.setText(null);
/*     */     
/* 241 */     this.txtMessages.append("Starting poker server...\n");
/* 242 */     this.pokerServer = new PokerServer(this.dlgServerSetup.getServerPort(), this.dlgServerSetup.getNumberOfPlayers(), this.dlgServerSetup.getInitialAmountOfChips(), this.dlgServerSetup.getInitialAnte(), this.dlgServerSetup.getRaiseAnteRoundsCount(), this.dlgServerSetup.getClientResponseTime(), this.dlgServerSetup.getDisplaySleepTime());
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 249 */     this.pokerServer.addTextReceiver(new ITextReceiver()
/*     */     {
/*     */       public void textReceived(Object sender, final String textMessage) {
/* 252 */         System.out.println(textMessage);
/* 253 */         javax.swing.SwingUtilities.invokeLater(new Runnable() {
/*     */           public void run() {
/* 255 */             PokerServerGuiView.this.txtMessages.append(textMessage + "\n");
/*     */           }
/*     */         });
/*     */       }
/* 259 */     });
/* 260 */     this.pokerServer.addGameObserver(new IGameObserver()
/*     */     {
/*     */       public void Standing(Object source, final String playerName, final int chipCount) {
/*     */         try {
/* 264 */           javax.swing.SwingUtilities.invokeAndWait(new Runnable()
/*     */           {
/*     */             public void run() {
/* 267 */               PokerServerGuiView.this.txtMessages.append("Standing: " + playerName + ": " + chipCount + " chips.\n");
/* 268 */               PokerServerGuiView.this.pokerTable.setPlayerStanding(playerName, chipCount);
/*     */             }
/*     */           });
/*     */         } catch (InterruptedException ex) {
/* 272 */           ex.printStackTrace();
/*     */         } catch (InvocationTargetException ex) {
/* 274 */           ex.printStackTrace();
/*     */         }
/*     */       }
/*     */       
/*     */       public void Hand(Object source, final String playerName, final ca.ualberta.cs.poker.Hand hand) {
/*     */         try {
/* 280 */           javax.swing.SwingUtilities.invokeAndWait(new Runnable()
/*     */           {
/*     */             public void run() {
/* 283 */               PokerServerGuiView.this.txtMessages.append("Hand: " + playerName + " has " + hand + " on hand.\n");
/* 284 */               PokerServerGuiView.this.pokerTable.setPlayerHand(playerName, hand);
/*     */             }
/*     */           });
/*     */         } catch (InterruptedException ex) {
/* 288 */           ex.printStackTrace();
/*     */         } catch (InvocationTargetException ex) {
/* 290 */           ex.printStackTrace();
/*     */         }
/*     */       }
/* 293 */     });
/* 294 */     this.pokerServer.addThreadObserver(new se.lypson.common.thread.IThreadObserver()
/*     */     {
/*     */       public void threadMessageEvent(se.lypson.common.thread.Thread thread, final Object message) {
/*     */         try {
/* 298 */           javax.swing.SwingUtilities.invokeAndWait(new Runnable()
/*     */           {
/*     */             public void run() {
/* 301 */               PokerServerGuiView.this.txtMessages.append("Poker Server: Thread message: " + message + "\n");
/*     */             }
/*     */           });
/*     */         } catch (InterruptedException ex) {
/* 305 */           ex.printStackTrace();
/*     */         } catch (InvocationTargetException ex) {
/* 307 */           ex.printStackTrace();
/*     */         }
/*     */       }
/*     */       
/*     */       public void threadFinishedEvent(se.lypson.common.thread.Thread thread) {
/*     */         try {
/* 313 */           javax.swing.SwingUtilities.invokeAndWait(new Runnable()
/*     */           {
/*     */             public void run() {
/* 316 */               PokerServerGuiView.this.txtMessages.append("Poker Server: Thread finished.\n");
/* 317 */               PokerServerGuiView.this.txtMessages.append("\n");
/* 318 */               PokerServerGuiView.this.txtMessages.append("\n");
/* 319 */               PokerServerGuiView.this.txtMessages.append("\n");
/* 320 */               PokerServerGuiView.this.txtMessages.append("Final results:\n");
/* 321 */               int i = 0;
/* 322 */               se.lypson.common.collections.IForwardIterator finalResult = PokerServerGuiView.this.pokerServer.getFinalResult();
/* 323 */               while (finalResult.hasNext()) {
/* 324 */                 PlayerResult playerResult = (PlayerResult)finalResult.next();
/* 325 */                 i++;
/* 326 */                 PokerServerGuiView.this.txtMessages.append("" + i + ": " + playerResult.getName() + ", " + playerResult.getPlayedRounds() + " rounds, " + playerResult.getRemainingChips() + " chips.\n");
/* 327 */                 PokerServerGuiView.this.pokerTable.setPlayerStanding(playerResult.getName(), playerResult.getRemainingChips());
/*     */               }
/*     */               
/* 330 */               PokerServerGuiView.this.tabMain.getModel().setSelectedIndex(0);
/*     */             }
/*     */           });
/*     */         } catch (InterruptedException ex) {
/* 334 */           ex.printStackTrace();
/*     */         } catch (InvocationTargetException ex) {
/* 336 */           ex.printStackTrace();
/*     */         }
/*     */       }
/* 339 */     });
/* 340 */     this.pokerServer.start();
/* 341 */     this.txtMessages.append("...done\n");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 361 */   private final javax.swing.Icon[] busyIcons = new javax.swing.Icon[15];
/* 362 */   private int busyIconIndex = 0;
/*     */   private javax.swing.JDialog aboutBox;
/*     */   private PokerServerSetupDialog dlgServerSetup;
/*     */   PokerServer pokerServer;
/*     */   PokerTablePanel pokerTable;
/*     */ }


/* Location:              /Users/Dawidejdeholm/Desktop/Skola/AI/PokerProject/PokerServerGUI/PokerServerGui.jar!/com/medicwave/cardgame/poker/PokerServerGuiView.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */