/*     */ package com.medicwave.cardgame.poker;
/*     */ 
/*     */ import ca.ualberta.cs.poker.Hand;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ServerPlayerData
/*     */ {
/*     */   public static final int STATUS_NORMAL = 0;
/*     */   public static final int STATUS_FOLDED = 1;
/*     */   public static final int STATUS_ALLIN = 2;
/*     */   public static final int STATUS_BROKE = 3;
/*     */   private static final String DEFAULT_NAME = "Unknown";
/*     */   private String name;
/*     */   private int clientID;
/*     */   private int status;
/*     */   private int remainingChips;
/*     */   private int chipsInPot;
/*     */   private int chipsWonCurrentRound;
/*     */   private Hand hand;
/*     */   private int rank;
/*     */   private int playedRounds;
/*     */   private int wonRounds;
/*     */   private boolean isConnected;
/*     */   
/*     */   public ServerPlayerData(int clientID)
/*     */   {
/*  43 */     this.clientID = clientID;
/*  44 */     this.status = 0;
/*  45 */     this.remainingChips = 0;
/*  46 */     this.chipsInPot = 0;
/*  47 */     this.name = ("Unknown" + clientID);
/*  48 */     this.playedRounds = 0;
/*  49 */     this.wonRounds = 0;
/*  50 */     this.hand = new Hand();
/*  51 */     this.isConnected = true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public int getClientID()
/*     */   {
/*  58 */     return this.clientID;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public String getName()
/*     */   {
/*  65 */     return this.name;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void setName(String name)
/*     */   {
/*  72 */     this.name = name;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public int getStatus()
/*     */   {
/*  80 */     return this.status;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void setStatus(int status)
/*     */   {
/*  87 */     this.status = status;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public int getRemainingChips()
/*     */   {
/*  95 */     return this.remainingChips;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void setRemainingChips(int remainingChips)
/*     */   {
/* 102 */     this.remainingChips = remainingChips;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void moveChipsToPot(int chipCount)
/*     */   {
/* 111 */     if ((chipCount < 0) || (chipCount > this.remainingChips)) {
/* 112 */       throw new IllegalArgumentException("Invalid amount of chips to move: '" + chipCount + "' is not in the interval [0, " + this.remainingChips + "]");
/*     */     }
/* 114 */     this.chipsInPot += chipCount;
/* 115 */     this.remainingChips -= chipCount;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public int getChipsInPot()
/*     */   {
/* 123 */     return this.chipsInPot;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void setChipsInPot(int chipsInPot)
/*     */   {
/* 130 */     this.chipsInPot = chipsInPot;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public int getRank()
/*     */   {
/* 139 */     return this.rank;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void calculateRank()
/*     */   {
/* 146 */     this.rank = PokerEvaluatorExtensions.getHandComparationRank(this.hand);
/*     */   }
/*     */   
/*     */ 
/*     */   public void resetRank()
/*     */   {
/* 152 */     this.rank = 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Hand getHand()
/*     */   {
/* 160 */     return this.hand;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public int getChipsWonCurrentRound()
/*     */   {
/* 168 */     return this.chipsWonCurrentRound;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void increaseChipsWonCurrentRound(int increase)
/*     */   {
/* 175 */     this.chipsWonCurrentRound += increase;
/*     */   }
/*     */   
/*     */ 
/*     */   public void resetChipsWonCurrentRound()
/*     */   {
/* 181 */     this.chipsWonCurrentRound = 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void moveChipsWonToRemainingChips()
/*     */   {
/* 188 */     this.remainingChips += this.chipsWonCurrentRound;
/* 189 */     this.chipsWonCurrentRound = 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public int getPlayedRounds()
/*     */   {
/* 197 */     return this.playedRounds;
/*     */   }
/*     */   
/*     */ 
/*     */   public void increasePlayedRounds()
/*     */   {
/* 203 */     this.playedRounds += 1;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public int getWonRounds()
/*     */   {
/* 211 */     return this.wonRounds;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void increaseWonRounds()
/*     */   {
/* 218 */     this.wonRounds += 1;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isConnected()
/*     */   {
/* 227 */     return this.isConnected;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setConnected(boolean isConnected)
/*     */   {
/* 235 */     this.isConnected = isConnected;
/*     */   }
/*     */ }


/* Location:              /Users/Dawidejdeholm/Desktop/Skola/AI/PokerProject/PokerServerGUI/PokerServerGui.jar!/com/medicwave/cardgame/poker/ServerPlayerData.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */