/*     */ package com.medicwave.socketlibrary;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.util.Enumeration;
/*     */ import java.util.Vector;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class StreamLineReaderThread
/*     */   extends se.lypson.common.thread.Thread
/*     */ {
/*     */   private InputStream inputStream;
/*  19 */   private volatile boolean stop = false;
/*  20 */   private final int DEFAULT_POLLING_INTERVAL = 1000;
/*  21 */   private int pollingTime = 1000;
/*     */   private boolean limitLinesToRead;
/*     */   private int numberOfLinesToRead;
/*  24 */   private Vector lineReadObservers = new Vector();
/*     */   
/*     */   public StreamLineReaderThread(InputStream inputStream) {
/*  27 */     this.inputStream = inputStream;
/*  28 */     this.limitLinesToRead = false;
/*  29 */     this.numberOfLinesToRead = -1;
/*     */   }
/*     */   
/*  32 */   public StreamLineReaderThread(InputStream inputStream, int numberOfLinesToRead) { this.inputStream = inputStream;
/*  33 */     this.limitLinesToRead = true;
/*  34 */     this.numberOfLinesToRead = numberOfLinesToRead;
/*     */   }
/*     */   
/*     */   public Object threadMain() throws Exception
/*     */   {
/*     */     try
/*     */     {
/*  41 */       StringBuffer buffer = new StringBuffer();
/*  42 */       while ((!this.limitLinesToRead) || (this.numberOfLinesToRead != 0))
/*     */       {
/*  44 */         while (this.inputStream.available() > 0)
/*     */         {
/*  46 */           int ch = this.inputStream.read();
/*     */           
/*  48 */           if (ch == -1)
/*     */           {
/*  50 */             this.stop = true;
/*  51 */             break;
/*     */           }
/*  53 */           if (ch == 10)
/*     */           {
/*     */ 
/*  56 */             if ((buffer.length() > 0) && (buffer.charAt(buffer.length() - 1) == '\r'))
/*     */             {
/*  58 */               buffer.deleteCharAt(buffer.length() - 1);
/*     */             }
/*     */             
/*     */ 
/*  62 */             notifyObserversLineRead(buffer.toString());
/*  63 */             buffer.setLength(0);
/*  64 */             this.numberOfLinesToRead -= 1;
/*     */           }
/*     */           else {
/*  67 */             buffer.append((char)ch);
/*     */           } }
/*  69 */         if (this.stop) {
/*     */           break;
/*     */         }
/*     */         try {
/*  73 */           Thread.sleep(this.pollingTime);
/*     */         }
/*     */         catch (InterruptedException ie) {}
/*     */       }
/*     */     }
/*     */     catch (IOException ioe) {
/*  79 */       ioe.printStackTrace();
/*  80 */       throw ioe;
/*     */     }
/*  82 */     return null;
/*     */   }
/*     */   
/*     */   public void close() {
/*  86 */     this.stop = true;
/*     */   }
/*     */   
/*     */   public void addLineReadObserver(ILineReadObserver observer) {
/*  90 */     if (observer == null) {
/*  91 */       throw new NullPointerException("Observer cannot be null.");
/*     */     }
/*  93 */     if (!this.lineReadObservers.contains(observer))
/*  94 */       this.lineReadObservers.addElement(observer);
/*     */   }
/*     */   
/*  97 */   public void removeLineReadObserver(ILineReadObserver observer) { this.lineReadObservers.removeElement(observer); }
/*     */   
/*     */   private void notifyObserversLineRead(String line)
/*     */   {
/* 101 */     Enumeration observersEnum = this.lineReadObservers.elements();
/* 102 */     while (observersEnum.hasMoreElements()) {
/*     */       try
/*     */       {
/* 105 */         ((ILineReadObserver)observersEnum.nextElement()).lineReadEvent(this, line);
/*     */       }
/*     */       catch (Exception e) {}
/*     */     }
/*     */   }
/*     */ }


/* Location:              /Users/Dawidejdeholm/Desktop/Skola/AI/PokerProject/PokerServerGUI/PokerServerGui.jar!/com/medicwave/socketlibrary/StreamLineReaderThread.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */